extends Node

var peer: ENetMultiplayerPeer = null

var last_num = 0

func _physics_process(delta):
	if peer:
		if not multiplayer.is_server() and peer.get_connection_status() == ENetMultiplayerPeer.CONNECTION_CONNECTED:
			set_num.rpc(last_num+1)

func start_as_server():
	peer = ENetMultiplayerPeer.new()
	peer.create_server(4444)
	multiplayer.multiplayer_peer = peer
	print("listening as server")


func start_as_client():
	peer = ENetMultiplayerPeer.new()
	peer.create_client('localhost', 4444)
	multiplayer.multiplayer_peer = peer
	print("connecting to server...")
	multiplayer.connected_to_server.connect(func (): print("connected to server"))


func _on_start_as_server_btn_pressed():
	start_as_server()


func _on_start_as_client_btn_pressed():
	start_as_client()


@rpc("any_peer", "call_local", "reliable", 1)
func set_num(num: int):
	if num != last_num +1:
		printerr("rpc missed!")
	last_num = num
	if multiplayer.is_server():
		print(num)
